package com.unitesk.reqcoverage;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.core.runtime.Platform;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;


/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "ttcn_requality"; //$NON-NLS-1$

	private static final String EXTENSION_NAME_NEW_TEST_DIALOGS = "com.requality.reqcoverage.newtestdialog";

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}
	
	public Map<String,Map<String,String>> getTestDescriptions(){
		Map<String, Map<String,String>> map = new HashMap<String, Map<String,String>>();
		IExtensionRegistry reg = Platform.getExtensionRegistry();
        IConfigurationElement[] configurationElements = reg
                .getConfigurationElementsFor(EXTENSION_NAME_NEW_TEST_DIALOGS);
        for (IConfigurationElement conf : configurationElements) {
            try {
            	String id = conf.getAttribute("id");
                map.put(id, new HashMap<String, String>());
                map.get(id).put("id", id);
                map.get(id).put("name", conf.getAttribute("name"));
                map.get(id).put("title", conf.getAttribute("title"));
                map.get(id).put("extension", conf.getAttribute("extension"));
                map.get(id).put("template", conf.getAttribute("template"));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return map;
		
	}

	public static String getPath(String string) {
		if (Activator.getDefault() == null) {
			return string;
		} else {
			URL url;
			try {
				url = FileLocator.toFileURL(
						Activator.getDefault().getBundle().getResource(string));
				return new File(url.toURI()).getAbsolutePath();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			catch (URISyntaxException e) {
				e.printStackTrace();
			}
		}
		return null;

	}
	public static List<IProject> getProjectsByNames(IProject targ,String[] split) {
		IWorkspace ws = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wr = ws.getRoot();
		List<IProject> projects = new ArrayList<IProject>();
		for(String s : split){
			if(s.equals(""))
				continue;
			IProject p = wr.getProject(s);
			if(p != null)
				projects.add(p);
		}
		return projects;
	}

	public static List<File> getContainersByNames(
			String string, String[] split) {
		List<File> projects = new ArrayList<File>();
		if(string==null)
			return projects;
		for(String s : split){
			if(s.equals(""))
				continue;
			//TODO handle 1 char
			s = s.substring(1);
			File cn = new File(string+File.separator+s);
			//cn = thisContainer .getFolder(new Path());
			if(cn != null && cn.exists())
				projects.add(cn);
		}
		return projects;
	}

	public static String getRelativePath(
			String string, File p) {
		String s1 = string;
		String s2;
		try {
			s2 = p.getCanonicalPath();
		} catch (IOException e) {
			e.printStackTrace();
			s2 = p.getAbsolutePath();
		}
		int sim = 0;
		while(sim<s1.length()&&sim<s2.length()&&s1.charAt(sim) == s2.charAt(sim))
			sim++;
		if(sim == 0)
			return "1"+s2;
		int ls = s1.lastIndexOf(File.separator);
		if(ls!=-1 && sim > ls)
			sim = ls+1;
		s1 = s1.substring(sim);
		s2 = s2.substring(sim);
		String buf = "."+File.separator;
		int cnt = 0;
		if(!s1.equals("")){
			while(cnt!=-1){
				cnt = s1.indexOf(File.separator,cnt);
				buf+=".."+File.separator;
			}
		}
		return "0"+buf+s2;
	}
}
